/// Filters the series to points within the specified time range.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct EnumTimeRangeFilterSeries {
    #[builder(custom(type = super::EnumSeries, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::EnumSeries>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::TimestampConstant>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "startTime", skip_serializing_if = "Option::is_none", default)]
    start_time: Option<Box<super::TimestampConstant>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::TimestampConstant>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "endTime", skip_serializing_if = "Option::is_none", default)]
    end_time: Option<Box<super::TimestampConstant>>,
}
impl EnumTimeRangeFilterSeries {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(input: super::EnumSeries) -> Self {
        Self::builder().input(input).build()
    }
    #[inline]
    pub fn input(&self) -> &super::EnumSeries {
        &*self.input
    }
    /// Represents the start time (inclusive) of the time range.
    #[inline]
    pub fn start_time(&self) -> Option<&super::TimestampConstant> {
        self.start_time.as_ref().map(|o| &**o)
    }
    /// Represents the end time (inclusive) of the time range.
    #[inline]
    pub fn end_time(&self) -> Option<&super::TimestampConstant> {
        self.end_time.as_ref().map(|o| &**o)
    }
}
